@use "sass:map";

@import "variables";

// --------
// -- Accessors
// --------

@function cui-font-size($size) {
  @return map.get($cui-font-size, $size);
}

@function cui-line-height($size) {
  @return map.get($cui-line-height, $size);
}

@function cui-height($size) {
  @return map.get($cui-height, $size);
}

@function cui-border-radius($size) {
  @return map.get($cui-border-radius, $size);
}

@function cui-color($name, $ref) {
  @return map.get(map.get($cui-palettes, $name), $ref);
}

// --------
// -- Typography
// --------

@mixin cui-head($level, $weight: $cui-font-weight-h) {
  font-size: map.get($cui-font-size-h, $level);
  line-height: map.get($cui-line-height-h, $level);
  font-weight: $weight;
}

@mixin cui-text($level, $weight: $cui-font-weight) {
  font-size: map.get($cui-font-size, $level);
  line-height: map.get($cui-line-height, $level);
  font-weight: $weight;
}

@mixin cui-break-word {
  word-wrap: break-word;
  word-break: break-word;
}

@mixin cui-ellipsis($lines: 1) {
  @if $lines == 1 {
    overflow: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;
  } @else {
    display: -webkit-box;
    -webkit-line-clamp: $lines;
    -webkit-box-orient: vertical;
    overflow: hidden;
  }
}

// --------
// -- Lists
// --------

@mixin cui-list-plain {
  list-style: none;
  padding-left: 0;
  margin-bottom: 0;
}

// --------
// -- Elevations
// --------

@mixin cui-elevation($level) {
  box-shadow: map.get($cui-elevation, $level);
}

@mixin cui-elevation-transition {
  transition: $cui-elevation-transition;
}

// --------
// -- Media
// --------

@mixin no-hover {
  @media (hover: none) {
    @content;
  }
}

@mixin hover {
  @media (hover: hover) {
    @content;
  }
}

// --------
// -- Visibility
// --------

/* stylelint-disable unit-allowed-list */
@mixin cui-visually-hidden {
  position: absolute !important;
  width: 1px !important;
  height: 1px !important;
  padding: 0 !important;
  margin: -1px !important;
  overflow: hidden !important;
  clip: rect(0, 0, 0, 0) !important;
  white-space: nowrap !important;
  border: 0 !important;
}
/* stylelint-enable unit-allowed-list */

@mixin cui-visually-hidden-focusable {
  &:not(:focus):not(:focus-within) {
    @include cui-visually-hidden;
  }
}

@mixin cui-visually-hidden-hoverable($container) {
  #{$container}:not(:hover):not(:focus):not(:focus-within) & {
    @include cui-visually-hidden;
  }
}

// --------
// -- Utilities
// --------

@mixin cui-select {
  -webkit-user-select: auto;
  -ms-user-select: auto;
  user-select: auto;
}

@mixin cui-no-select {
  -webkit-user-select: none;
  -ms-user-select: none;
  user-select: none;
}

@mixin cui-ratio($aspect-ratio) {
  position: relative;
  width: 100%;

  &::before {
    display: block;
    padding-top: $aspect-ratio;
    content: "";
  }

  > * {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
  }
}

// --------
// -- Media queries
// --------

/* stylelint-disable unit-allowed-list */
@mixin until($breakpoint, $media-type: screen) {
    @media #{$media-type} and (max-width: #{map.get($breakpoints, $breakpoint) - 1px}) {
      @content;
    }
}

@mixin from($breakpoint, $media-type: screen) {
    @media #{$media-type} and (min-width: #{map.get($breakpoints, $breakpoint)}) {
      @content;
    }
}
/* stylelint-enable unit-allowed-list */
